commit e6baa800897728fac40fc7153facaf3c7541ff3f
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Nov 28 14:28:53 2022

    libstdc++: Fix src/c++17/memory_resource for H8 targets [PR107801]
    
    This fixes compilation failures for H8 multilibs. For the normal
    multilib (ILP16L32?), the chunk struct does not have the expected size,
    because uint32_t is type long and has alignment 4 (by default). This
    forces sizeof(chunk) to be 12 instead of the expected 10. We can fix
    that by using bitset::size_type instead of uint32_t, so that we only use
    a 16-bit size when size_t and pointers are 16-bit types.
    
    For the IL32P16 multilibs that use -mint32, int is wider than size_t
    and so arithmetic expressions involving size_t promote to int. This
    means we need some explicit casts back to size_t.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/107801
            * src/c++17/memory_resource.cc (chunk::_M_bytes): Change type
            from uint32_t to bitset::size_type. Adjust static assertion.
            (__pool_resource::_Pool::replenish): Cast to size_t after
            multiplication instead of before.
            (__pool_resource::_M_alloc_pools): Ensure both arguments to
            std::max have type size_t.
    
    (cherry picked from commit 75e562d2c4303d3918be9d1563284b0c580c5e45)

diff --git a/libstdc++-v3/src/c++17/memory_resource.cc b/libstdc++-v3/src/c++17/memory_resource.cc
index d6555aa8823..b7a1a716c42 100644
--- a/libstdc++-v3/src/c++17/memory_resource.cc
+++ b/libstdc++-v3/src/c++17/memory_resource.cc
@@ -506,7 +506,7 @@ namespace pmr
     }
 
     // Allocated size of chunk:
-    uint32_t _M_bytes = 0;
+    bitset::size_type _M_bytes = 0;
     // Start of allocated chunk:
     std::byte* _M_p = nullptr;
 
@@ -580,7 +580,7 @@ namespace pmr
   // For 16-bit pointers it's five pointers (10 bytes).
   // TODO pad 64-bit to 4*sizeof(void*) to avoid splitting across cache lines?
   static_assert(sizeof(chunk)
-      == sizeof(bitset::size_type) + sizeof(uint32_t) + 2 * sizeof(void*));
+      == 2 * sizeof(bitset::size_type) + 2 * sizeof(void*));
 
   // An oversized allocation that doesn't fit in a pool.
   struct big_block
@@ -735,7 +735,7 @@ namespace pmr
 	  _M_blocks_per_chunk = std::min({
 	      max_blocks,
 	      __opts.max_blocks_per_chunk,
-	      (size_t)_M_blocks_per_chunk * 2
+	      size_t(_M_blocks_per_chunk * 2)
 	  });
 	}
     }
@@ -1058,7 +1058,8 @@ namespace pmr
 	// Decide on initial number of blocks per chunk.
 	// At least 16 blocks per chunk seems reasonable,
 	// more for smaller blocks:
-	size_t blocks_per_chunk = std::max(size_t(16), 1024 / block_size);
+	size_t blocks_per_chunk = 1024 / block_size;
+	blocks_per_chunk = std::max(size_t(16), blocks_per_chunk);
 	// But don't exceed the requested max_blocks_per_chunk:
 	blocks_per_chunk
 	  = std::min(blocks_per_chunk, _M_opts.max_blocks_per_chunk);

